/*!
 * \file personnage.c
 * \brief Character Source File
 * \authors Lucile, Tin
 * \version 2
 * \date 02/03/2021
 *
 * Character functions implementation.
 *
 */

#include "personnage.h"

/*!
 * \fn void init_pers(Personnage * character, int x, int y, int length, int width, int speed)
 * \brief This function initializes the character : position of the character's top left corner (x,y), size (length, width), and also her speed.
 *
 * \param [in] character A pointer on the character
 * \param [in] x The character's abscissa
 * \param [in] y The character's ordinate
 * \param [in] length The character's length
 * \param [in] width The character's width
 * \param [in] speed The character's speed
 */

void init_pers(Personnage * character, int x, int y, int length, int width, int speed){

	character->x_pers=x;
    character->y_pers=y;
    character->long_pers=length;
    character->larg_pers=width;
    character->speed_pers=speed;
    character->animation.direction_personnage = 0;
    character->animation.index_image = 0;
    character->result=PLAYING;
    character->last_direction=0;
}

/*!
 * \fn void calcul_points_pers(Personnage * character)
 * \brief This function calculates the position of the 3 other character's corners.
 *
 * \param [in] character A pointer on the character
 */

void calcul_points_pers(Personnage * character){
    //calculate 3 others points of rectangle
    character->x_hr = character->x_pers + character->larg_pers ;
    character->y_hr = character->y_pers;
    character->x_ll = character->x_pers;
    character->y_ll = character->y_pers + character->long_pers;
    character->x_lr = character->x_pers + character->larg_pers;
    character->y_lr = character->y_pers + character->long_pers;
}
