/*!
 * \file timer.c
 * \brief Teacher Source File
 * \authors Kaan, Tin
 * \version 2
 * \date 09/04/2021
 *
 * Timer functions implementation.
 *
 */

#include <time.h>
#include "timer.h"
#include "personnage.h"

clock_t begin;
int time_spent;



void init_timer(){
    begin=clock();
}

/*!
 * \fn void timer_countdown(Personnage *hero, long seconde, int* time_remaining)
 * \brief This function calculates the time remaining, and change the result of the game if there is no time left.
 *
 * \param [in] hero A hero pointer
 * \param [in] seconde The time to count down
 * \param [in] time_remaining The pointer to the time remaining
 */

void timer_countdown(Personnage *hero, long seconde, int* time_remaining){
    time_spent = (clock() - begin) / CLOCKS_PER_SEC;
    *time_remaining= (int) (seconde-time_spent);

	
    if(*time_remaining==0){
        hero->result=LOSE;
    }


}

