/*!
 * \file window.c
 * \brief Window Source File
 * \authors Lucile
 * \version 2
 * \date 04/04/2021
 *
 * Window functions implementation.
 *
 */

#include "window.h"

/*!
 * \fn void init_window(Window * window, int level, int time, int id_window)
 * \brief This function initializes a window.
 *
 * \param [in] window A pointer on a window.
 * \param [in] level Level's number, -1 if none.
 * \param [in] time The level's time, -1 otherwise (no timing).
 * \param [in] id_window Window's type.
 */

void init_window(Window * window, int level, int time, int id_window) {
    window->id_window=id_window;
    if(id_window==LEVEL){
        window->level=level;
        window->time=time;
    } else {
        window->level=-1;
        window->time=-1;
    }
}