/*!
 * \file prof.c
 * \brief Teacher Source File
 * \authors Corto
 * \version 1
 * \date 02/03/2021
 *
 * Teacher functions implementation.
 *
 */


#include "prof.h"

/*!
 * \fn void init_prof(Prof * prof, int x, int y, int length, int width, int speed)
 * \brief This function initializes the teacher : position of the teacher's top left corner (x,y), size (length, width) and also his speed
 *
 * \param [in] prof A pointer on the teacher
 * \param [in] x The teacher's abscissa
 * \param [in] y The teacher's ordinate
 * \param [in] length The teacher's length
 * \param [in] width The teacher's width
 * \param [in] speed The teacher's speed
 */

void init_prof(Prof * prof, int x, int y, int length, int width, int speed){
    prof->x_prof=x;
    prof->y_prof=y;
    prof->long_prof=length;
    prof->larg_prof=width;
    prof->speed_prof=speed;
	prof->animation.direction_teacher = 0;
    prof->animation.index_image = 0;
}

/*!
 * \fn void calcul_points_prof(Prof * prof)
 * \brief This function calculates the 3 others corners of the teacher
 *
 * \param [in] Teacher A pointer on the character
 */

void calcul_points_prof(Prof * prof){
    prof->x_hr = prof->x_prof + prof->larg_prof ;
    prof->y_hr = prof->y_prof;
    prof->x_ll = prof->x_prof;
    prof->y_ll = prof->y_prof + prof->long_prof;
    prof->x_lr = prof->x_prof + prof->larg_prof;
    prof->y_lr = prof->y_prof + prof->long_prof;
}