/*
// Created by Tiny on 5/19/2021.
*/

#ifndef INSAGAMETEST_TEST_GAME_H
#define INSAGAMETEST_TEST_GAME_H
#include <gtest/gtest.h>
extern "C"{
#include "GAME.h"
#include "personnage.h"
#include "window.h"
}

TEST(test_calculer_score, lose_at_first_level_touch_3_time){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=0;
    person.DS_took=0;
    person.life=0;

    Window window_play;
    init_window(&window_play,1,30,LEVEL);

    int time_remaining = 20;

    person.result=LOSE;

    int score = calculer_score(&person,time_remaining,&window_play);

    EXPECT_EQ(score,0);
}

TEST(test_calculer_score, lose_at_first_level_time_out){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=0;
    person.DS_took=0;
    person.life=3;

    Window window_play;
    init_window(&window_play,1,30,LEVEL);

    int time_remaining = 0;

    person.result=LOSE;

    int score = calculer_score(&person,time_remaining,&window_play);

    EXPECT_EQ(score,0);
}


TEST(test_calculer_score, lose_at_level_3_touch_3_times_with_already_100pts){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=1000;
    person.DS_took=2;
    person.life=0;

    Window window_play;
    init_window(&window_play,3,15,LEVEL);

    int time_remaining = 4;

    person.result=LOSE;

    int score = calculer_score(&person,time_remaining,&window_play);

    EXPECT_EQ(score,2000);
}

TEST(test_calculer_score, lose_at_level_3_timeout_with_already_100pts){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=1000;
    person.DS_took=2;
    person.life=2;

    Window window_play;
    init_window(&window_play,3,15,LEVEL);

    int time_remaining = 0;

    person.result=LOSE;

    int score = calculer_score(&person,time_remaining,&window_play);

    EXPECT_EQ(score,2000);
}

TEST(test_calculer_score, test_level_up_1_10_s_remaining){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=0;
    person.DS_took=2;
    person.life=2;

    Window window_play;
    init_window(&window_play,1,30,LEVEL);

    int time_remaining = 10;

    int score_total = calculer_score(&person,time_remaining,&window_play);


    EXPECT_EQ(person.score,100);
    EXPECT_EQ(score_total,0);
}

TEST(test_calculer_score, test_level_up_5_10_s_remaining_already_1000){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=1000;
    person.DS_took=2;
    person.life=2;

    Window window_play;
    init_window(&window_play,5,30,LEVEL);

    int time_remaining = 10;

    int score_total = calculer_score(&person,time_remaining,&window_play);


    EXPECT_EQ(person.score,1300);
    EXPECT_EQ(score_total,0);
}

TEST(test_calculer_score, test_level_up_8_10_s_remaining_already_3000){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=3000;
    person.DS_took=2;
    person.life=2;

    Window window_play;
    init_window(&window_play,5,30,LEVEL);

    int time_remaining = 10;

    int score_total = calculer_score(&person,time_remaining,&window_play);


    EXPECT_EQ(person.score,3300);
    EXPECT_EQ(score_total,0);
}

TEST(test_calculer_score, test_win_1_life_already_5000_pts){

    Personnage  person;
    init_pers(&person,3,3,3,3,5);
    person.score=5000;
    person.DS_took=2;
    person.life=1;

    Window window_play;
    init_window(&window_play,-1,-1,WIN);

    person.result=WIN;
    int time_remaining = 10;

    int score_total = calculer_score(&person,time_remaining,&window_play);

    EXPECT_EQ(score_total,16000);
}


#endif /*INSAGAMETEST_TEST_GAME_H*/
