/*
// Created by Tiny on 3/18/2021.
*/

#ifndef MAIN_C_TEST_MAP_H
#define MAIN_C_TEST_MAP_H

#include <gtest/gtest.h>
#include <stdio.h>
extern "C"{
#include "map.h"
}

TEST(test_init_map_strings,with_real_path){
    MAP map;
    init_map(&map, "../ressource/colored.bmp", "../ressource/map_play.bmp");
    EXPECT_STREQ("../ressource/colored.bmp",map.functional_path);
	EXPECT_STREQ("../ressource/map_play.bmp",map.visual_path);
	EXPECT_TRUE(map.functional);
}

TEST(test_init_map,with_false_path){
    MAP map;
    init_map(&map, "coloro.bmp", "mapvis.bmp");
	EXPECT_FALSE(map.functional);
}

TEST(test_map_to_matrix_height_length,with_real_play_image){
    MAP map;
    init_map(&map, "../ressource/colored.bmp", "../ressource/map_play.bmp");
	EXPECT_EQ(700,map.height);
    EXPECT_EQ(700,map.width);
}

TEST(test_map_to_matrix_height_length,with_ez_image){
    MAP map;
    init_map(&map, "../ressource/func_test_map.bmp", "../ressource/map_play.bmp");
    EXPECT_EQ(3,map.height);
    EXPECT_EQ(9,map.width);
}





#endif /*MAIN_C_TEST_PROF_H*/
